/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Jaap Haitsma.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Tracy Norris (tnorris@nc.rr.com), Jesper Kristensen (jesper@nc.rr.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
 
 // This holds the object for accessing the preferences
 var autofillPrefs = Components.classes["@mozilla.org/preferences-service;1"].
                             getService(Components.interfaces.nsIPrefService).getBranch("autofill.");
 
 const CURRENT_VERSION="0.1";

function setInternalPrefs()
{
	// Populate the internal preferences if this is the first install, or a version mismatch
	if (!autofillPrefs.prefHasUserValue("version")||autofillPrefs.getCharPref("version")!=CURRENT_VERSION) {
		// debug flag
		autofillPrefs.setBoolPref("debug",false);

		consoleDump("Setting Internal Preferences");
		
		autofillPrefs.setCharPref("version",CURRENT_VERSION);

		// form name associations
		autofillPrefs.setCharPref("form_name.title","Ecom_ShipTo_Postal_Name_Prefix,Ecom_BillTo_Postal_Name_Prefix,Ecom_ReceiptTo_Postal_Name_Prefix");
		autofillPrefs.setCharPref("form_name.first_name","Ecom_ShipTo_Postal_Name_First,Ecom_BillTo_Postal_Name_First,Ecom_ReceiptTo_Postal_Name_First,first_name,firstname,first,fname");
		autofillPrefs.setCharPref("form_name.middle_name","Ecom_ShipTo_Postal_Name_Middle,Ecom_BillTo_Postal_Name_Middle,Ecom_ReceiptTo_Postal_Name_Middle,middle_name,middlename,middle,mname");
		autofillPrefs.setCharPref("form_name.last_name","Ecom_ShipTo_Postal_Name_Last,Ecom_BillTo_Postal_Name_Last,Ecom_ReceiptTo_Postal_Name_Last,last_name,lastname,last,lname");
		autofillPrefs.setCharPref("form_name.suffix","Ecom_ShipTo_Postal_Name_Suffix,Ecom_BillTo_Postal_Name_Suffix,Ecom_ReceiptTo_Postal_Name_Suffix");
		autofillPrefs.setCharPref("form_name.email_address","Ecom_ShipTo_Online_Email,Ecom_BillTo_Online_Email,Ecom_ReceiptTo_Online_Email,email,retype_email,email1,email2");
		autofillPrefs.setCharPref("form_name.phone_number","Ecom_ShipTo_Telecom_Phone_Number,Ecom_BillTo_Telecom_Phone_Number,Ecom_ReceiptTo_Telecom_Phone_Number,phone");

		// internal form name associations
		autofillPrefs.setCharPref("form_name.full_name","full_name,name");
		
		autofillPrefs.setCharPref("form_name.primary_line1","Ecom_BillTo_Postal_Street_Line1,Ecom_ReceiptTo_Postal_Street_Line1,addr1,street1,address1,add1,address,add,street");
		autofillPrefs.setCharPref("form_name.primary_line2","Ecom_BillTo_Postal_Street_Line2,Ecom_ReceiptTo_Postal_Street_Line2,addr2,street2,address2,add2");
		autofillPrefs.setCharPref("form_name.primary_city","Ecom_BillTo_Postal_City,Ecom_ReceiptTo_Postal_City,city");
		autofillPrefs.setCharPref("form_name.primary_state","Ecom_BillTo_Postal_StateProv,Ecom_ReceiptTo_Postal_StateProv,state,statecode");
		autofillPrefs.setCharPref("form_name.primary_zip","Ecom_BillTo_Postal_PostalCode,Ecom_ReceiptTo_Postal_PostalCode,zip,zipcode");
		autofillPrefs.setCharPref("form_name.primary_country","country");
		autofillPrefs.setCharPref("form_name.primary_country_code","Ecom_BillTo_Postal_CountryCode,Ecom_ReceiptTo_Postal_CountryCode");

		autofillPrefs.setCharPref("form_name.secondary_line1","Ecom_ShipTo_Postal_Street_Line1");
		autofillPrefs.setCharPref("form_name.secondary_line2","Ecom_ShipTo_Postal_Street_Line2");
		autofillPrefs.setCharPref("form_name.secondary_city","Ecom_ShipTo_Postal_City");
		autofillPrefs.setCharPref("form_name.secondary_state","Ecom_ShipTo_Postal_StateProv");
		autofillPrefs.setCharPref("form_name.secondary_zip","Ecom_ShipTo_Postal_PostalCode");
		autofillPrefs.setCharPref("form_name.secondary_country","country");
		autofillPrefs.setCharPref("form_name.secondary_country_code","Ecom_ShipTo_Postal_CountryCode");
	}
}

function consoleDump(aText) {
	if (autofillPrefs.getBoolPref("debug"))
	{
		var csClass = Components.classes['@mozilla.org/consoleservice;1'];
		var cs = csClass.getService(Components.interfaces.nsIConsoleService);
		cs.logStringMessage(aText);
	}
}

function clearMenu(aParent) {
  var children = aParent.childNodes;
  for (var i = 0; i < children.length; i++) {
      var index = children[i].getAttribute("index");
      if (index)
        aParent.removeChild(children[i]);
   }
}

var countries=new Array();
countries["AF"]="Afghanistan";
countries["AX"]="land Islands";
countries["AL"]="Albania";
countries["DZ"]="Algeria";
countries["AS"]="American Samoa";
countries["AD"]="Andorra";
countries["AO"]="Angola";
countries["AI"]="Anguilla";
countries["AQ"]="Antarctica";
countries["AG"]="Antigua And Barbuda";
countries["AR"]="Argentina";
countries["AM"]="Armenia";
countries["AW"]="Aruba";
countries["AU"]="Australia";
countries["AT"]="Austria";
countries["AZ"]="Azerbaijan";
countries["BS"]="Bahamas";
countries["BH"]="Bahrain";
countries["BD"]="Bangladesh";
countries["BB"]="Barbados";
countries["BY"]="Belarus";
countries["BE"]="Belgium";
countries["BZ"]="Belize";
countries["BJ"]="Benin";
countries["BM"]="Bermuda";
countries["BT"]="Bhutan";
countries["BO"]="Bolivia";
countries["BA"]="Bosnia And Herzegovina";
countries["BW"]="Botswana";
countries["BV"]="Bouvet Island";
countries["BR"]="Brazil";
countries["IO"]="British Indian Ocean Territory";
countries["BN"]="Brunei Darussalam";
countries["BG"]="Bulgaria";
countries["BF"]="Burkina Faso";
countries["BI"]="Burundi";
countries["KH"]="Cambodia";
countries["CM"]="Cameroon";
countries["CA"]="Canada";
countries["CV"]="Cape Verde";
countries["KY"]="Cayman Islands";
countries["CF"]="Central African Republic";
countries["TD"]="Chad";
countries["CL"]="Chile";
countries["CN"]="China";
countries["CX"]="Christmas Island";
countries["CC"]="Cocos (keeling) Islands";
countries["CO"]="Colombia";
countries["KM"]="Comoros";
countries["CG"]="Congo";
countries["CD"]="Congo, The Democratic Republic Of The";
countries["CK"]="Cook Islands";
countries["CR"]="Costa Rica";
countries["CI"]="Cte D'ivoire";
countries["HR"]="Croatia";
countries["CU"]="Cuba";
countries["CY"]="Cyprus";
countries["CZ"]="Czech Republic";
countries["DK"]="Denmark";
countries["DJ"]="Djibouti";
countries["DM"]="Dominica";
countries["DO"]="Dominican Republic";
countries["EC"]="Ecuador";
countries["EG"]="Egypt";
countries["SV"]="El Salvador";
countries["GQ"]="Equatorial Guinea";
countries["ER"]="Eritrea";
countries["EE"]="Estonia";
countries["ET"]="Ethiopia";
countries["FK"]="Falkland Islands (Malvinas)";
countries["FO"]="Faroe Islands";
countries["FJ"]="Fiji";
countries["FI"]="Finland";
countries["FR"]="France";
countries["GF"]="French Guiana";
countries["PF"]="French Polynesia";
countries["TF"]="French Southern Territories";
countries["GA"]="Gabon";
countries["GM"]="Gambia";
countries["GE"]="Georgia";
countries["DE"]="Germany";
countries["GH"]="Ghana";
countries["GI"]="Gibraltar";
countries["GR"]="Greece";
countries["GL"]="Greenland";
countries["GD"]="Grenada";
countries["GP"]="Guadeloupe";
countries["GU"]="Guam";
countries["GT"]="Guatemala";
countries["GN"]="Guinea";
countries["GW"]="Guinea-bissau";
countries["GY"]="Guyana";
countries["HT"]="Haiti";
countries["HM"]="Heard Island And Mcdonald Islands";
countries["VA"]="Holy See (vatican City State)";
countries["HN"]="Honduras";
countries["HK"]="Hong Kong";
countries["HU"]="Hungary";
countries["IS"]="Iceland";
countries["IN"]="India";
countries["ID"]="Indonesia";
countries["IR"]="Iran, Islamic Republic Of";
countries["IQ"]="Iraq";
countries["IE"]="Ireland";
countries["IL"]="Israel";
countries["IT"]="Italy";
countries["JM"]="Jamaica";
countries["JP"]="Japan";
countries["JO"]="Jordan";
countries["KZ"]="Kazakhstan";
countries["KE"]="Kenya";
countries["KI"]="Kiribati";
countries["KP"]="Korea, Democratic People's Republic Of";
countries["KR"]="Korea, Republic Of";
countries["KW"]="Kuwait";
countries["KG"]="Kyrgyzstan";
countries["LA"]="Lao People's Democratic Republic";
countries["LV"]="Latvia";
countries["LB"]="Lebanon";
countries["LS"]="Lesotho";
countries["LR"]="Liberia";
countries["LY"]="Libyan Arab Jamahiriya";
countries["LI"]="Liechtenstein";
countries["LT"]="Lithuania";
countries["LU"]="Luxembourg";
countries["MO"]="Macao";
countries["MK"]="Macedonia, The Former Yugoslav Republic Of";
countries["MG"]="Madagascar";
countries["MW"]="Malawi";
countries["MY"]="Malaysia";
countries["MV"]="Maldives";
countries["ML"]="Mali";
countries["MT"]="Malta";
countries["MH"]="Marshall Islands";
countries["MQ"]="Martinique";
countries["MR"]="Mauritania";
countries["MU"]="Mauritius";
countries["YT"]="Mayotte";
countries["MX"]="Mexico";
countries["FM"]="Micronesia, Federated States Of";
countries["MD"]="Moldova, Republic Of";
countries["MC"]="Monaco";
countries["MN"]="Mongolia";
countries["MS"]="Montserrat";
countries["MA"]="Morocco";
countries["MZ"]="Mozambique";
countries["MM"]="Myanmar";
countries["NA"]="Namibia";
countries["NR"]="Nauru";
countries["NP"]="Nepal";
countries["NL"]="Netherlands";
countries["AN"]="Netherlands Antilles";
countries["NC"]="New Caledonia";
countries["NZ"]="New Zealand";
countries["NI"]="Nicaragua";
countries["NE"]="Niger";
countries["NG"]="Nigeria";
countries["NU"]="Niue";
countries["NF"]="Norfolk Island";
countries["MP"]="Northern Mariana Islands";
countries["NO"]="Norway";
countries["OM"]="Oman";
countries["PK"]="Pakistan";
countries["PW"]="Palau";
countries["PS"]="Palestinian Territory, Occupied";
countries["PA"]="Panama";
countries["PG"]="Papua New Guinea";
countries["PY"]="Paraguay";
countries["PE"]="Peru";
countries["PH"]="Philippines";
countries["PN"]="Pitcairn";
countries["PL"]="Poland";
countries["PT"]="Portugal";
countries["PR"]="Puerto Rico";
countries["QA"]="Qatar";
countries["RE"]="Runion";
countries["RO"]="Romania";
countries["RU"]="Russian Federation";
countries["RW"]="Rwanda";
countries["SH"]="Saint Helena";
countries["KN"]="Saint Kitts And Nevis";
countries["LC"]="Saint Lucia";
countries["PM"]="Saint Pierre And Miquelon";
countries["VC"]="Saint Vincent And The Grenadines";
countries["WS"]="Samoa";
countries["SM"]="San Marino";
countries["ST"]="Sao Tome And Principe";
countries["SA"]="Saudi Arabia";
countries["SN"]="Senegal";
countries["CS"]="Serbia And Montenegro";
countries["SC"]="Seychelles";
countries["SL"]="Sierra Leone";
countries["SG"]="Singapore";
countries["SK"]="Slovakia";
countries["SI"]="Slovenia";
countries["SB"]="Solomon Islands";
countries["SO"]="Somalia";
countries["ZA"]="South Africa";
countries["GS"]="South Georgia And The South Sandwich Islands";
countries["ES"]="Spain";
countries["LK"]="Sri Lanka";
countries["SD"]="Sudan";
countries["SR"]="Suriname";
countries["SJ"]="Svalbard And Jan Mayen";
countries["SZ"]="Swaziland";
countries["SE"]="Sweden";
countries["CH"]="Switzerland";
countries["SY"]="Syrian Arab Republic";
countries["TW"]="Taiwan, Province Of China";
countries["TJ"]="Tajikistan";
countries["TZ"]="Tanzania, United Republic Of";
countries["TH"]="Thailand";
countries["TL"]="Timor-leste";
countries["TG"]="Togo";
countries["TK"]="Tokelau";
countries["TO"]="Tonga";
countries["TT"]="Trinidad And Tobago";
countries["TN"]="Tunisia";
countries["TR"]="Turkey";
countries["TM"]="Turkmenistan";
countries["TC"]="Turks And Caicos Islands";
countries["TV"]="Tuvalu";
countries["UG"]="Uganda";
countries["UA"]="Ukraine";
countries["AE"]="United Arab Emirates";
countries["GB"]="United Kingdom";
countries["US"]="United States";
countries["UM"]="United States Minor Outlying Islands";
countries["UY"]="Uruguay";
countries["UZ"]="Uzbekistan";
countries["VU"]="Vanuatu";
countries["VE"]="Venezuela";
countries["VN"]="Viet Nam";
countries["VG"]="Virgin Islands, British";
countries["VI"]="Virgin Islands, U.s.";
countries["WF"]="Wallis And Futuna";
countries["EH"]="Western Sahara";
countries["YE"]="Yemen";
countries["ZM"]="Zambia";
countries["ZW"]="Zimbabwe";
 