/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Jaap Haitsma.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Tracy Norris (tnorris@nc.rr.com), Jesper Kristensen (jesper@nc.rr.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var autofillProfileName=new Array();

var autofillTitle=new Array();
var autofillFirstName=new Array();
var autofillMiddleName=new Array();
var autofillLastName=new Array();
var autofillSuffix=new Array();
var autofillEmailAddress=new Array();
var autofillPhoneNumber=new Array();

var autofillPrimaryLine1=new Array();
var autofillPrimaryLine2=new Array();
var autofillPrimaryCity=new Array();
var autofillPrimaryState=new Array();
var autofillPrimaryZip=new Array();
var autofillPrimaryCountryCode=new Array();

var autofillUsePrimary=new Array();

var autofillSecondaryLine1=new Array();
var autofillSecondaryLine2=new Array();
var autofillSecondaryCity=new Array();
var autofillSecondaryState=new Array();
var autofillSecondaryZip=new Array();
var autofillSecondaryCountryCode=new Array();

function usePrimaryListener() {
	if (document.getElementById('use_primary').checked) {
		document.getElementById('autofill_secondary_line1').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_line2').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_city').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_state').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_zip').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_country').setAttribute("disabled","true");
	}
	else {
		document.getElementById('autofill_secondary_line1').removeAttribute("disabled");
		document.getElementById('autofill_secondary_line2').removeAttribute("disabled");
		document.getElementById('autofill_secondary_city').removeAttribute("disabled");
		document.getElementById('autofill_secondary_state').removeAttribute("disabled");
		document.getElementById('autofill_secondary_zip').removeAttribute("disabled");
		document.getElementById('autofill_secondary_country').removeAttribute("disabled");
	}

	// Save Use Primary Checkbox
	autofillUsePrimary[document.getElementById("profile_menu").selectedIndex]=document.getElementById("use_primary").checked;

}

function doOK() {

	
	if (autofillPrefs.prefHasUserValue("selected_profile_id"))
		selectedProfileId=autofillPrefs.getCharPref("selected_profile_id");
	else
		selectedProfileId="";
	
	deleteProfilePreferences();
	
	// Options
	autofillPrefs.setBoolPref("autohighlight",document.getElementById("autofill_autohighlight").checked);

	var profileString="";
	var found=false;
	
	for (var i=0;i<autofillProfileName.length;++i) {
	
		// is the selected profile in the list of profiles?
		if (selectedProfileId==autofillProfileName[i])
			found=true;
			
		profileString += autofillProfileName[i];
		profileString += ",";
		
		// General Elements
		autofillPrefs.setCharPref(autofillProfileName[i]+".title",autofillTitle[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".first_name",autofillFirstName[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".middle_name",autofillMiddleName[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".last_name",autofillLastName[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".suffix",autofillSuffix[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".email_address",autofillEmailAddress[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".phone_number",autofillPhoneNumber[i]);

		// Primary Address
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_line1",autofillPrimaryLine1[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_line2",autofillPrimaryLine2[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_city",autofillPrimaryCity[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_state",autofillPrimaryState[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_zip",autofillPrimaryZip[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_country_code",autofillPrimaryCountryCode[i]);
		
		if (autofillPrimaryCountryCode[i]!="")
			autofillPrefs.setCharPref(autofillProfileName[i]+".primary_country",countries[autofillPrimaryCountryCode[i]]);
		else
			autofillPrefs.setCharPref(autofillProfileName[i]+".primary_country","");
		

		// Use Primary Address
		autofillPrefs.setBoolPref(autofillProfileName[i]+".use_primary",autofillUsePrimary[i]);

		// Secondary Address
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_line1",autofillSecondaryLine1[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_line2",autofillSecondaryLine2[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_city",autofillSecondaryCity[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_state",autofillSecondaryState[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_zip",autofillSecondaryZip[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_country_code",autofillSecondaryCountryCode[i]);

		if (autofillSecondaryCountryCode[i]!="")
			autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_country",countries[autofillSecondaryCountryCode[i]]);
		else
			autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_country","");			
	}
	
	// if the selected profile is in the list or there is only one profile, reset it accordingly, otherwise reset it
	if (found)
		autofillPrefs.setCharPref("selected_profile_id",selectedProfileId);
	else if (autofillProfileName.length==1)
		autofillPrefs.setCharPref("selected_profile_id",autofillProfileName[0]);
	else
		autofillPrefs.setCharPref("selected_profile_id","");
		
	// lop off the last comma
	profileString=profileString.substring(0,profileString.length-1);
	
	autofillPrefs.setCharPref("profile_list",profileString);
		
	return true;
}

function deleteProfilePreferences() {
			// save internal preferences
			var formNameTitle=autofillPrefs.getCharPref("form_name.title");
			var formNameFirstName=autofillPrefs.getCharPref("form_name.first_name");
			var formNameMiddleName=autofillPrefs.getCharPref("form_name.middle_name");
			var formNameLastName=autofillPrefs.getCharPref("form_name.last_name");
			var formNameSuffix=autofillPrefs.getCharPref("form_name.suffix");
			var formNameEmailAddress=autofillPrefs.getCharPref("form_name.email_address");
			var formNamePhoneNumber=autofillPrefs.getCharPref("form_name.phone_number");
	
			var formNameFullName=autofillPrefs.getCharPref("form_name.full_name");
			
			var formNamePrimaryLine1=autofillPrefs.getCharPref("form_name.primary_line1");
			var formNamePrimaryLine2=autofillPrefs.getCharPref("form_name.primary_line2");
			var formNamePrimaryCity=autofillPrefs.getCharPref("form_name.primary_city");
			var formNamePrimaryState=autofillPrefs.getCharPref("form_name.primary_state");
			var formNamePrimaryZip=autofillPrefs.getCharPref("form_name.primary_zip");
			var formNamePrimaryCountry=autofillPrefs.getCharPref("form_name.primary_country");
			var formNamePrimaryCountryCode=autofillPrefs.getCharPref("form_name.primary_country_code");
	
			var formNameSecondaryLine1=autofillPrefs.getCharPref("form_name.secondary_line1");
			var formNameSecondaryLine2=autofillPrefs.getCharPref("form_name.secondary_line2");
			var formNameSecondaryCity=autofillPrefs.getCharPref("form_name.secondary_city");
			var formNameSecondaryState=autofillPrefs.getCharPref("form_name.secondary_state");
			var formNameSecondaryZip=aut=autofillPrefs.getCharPref("form_name.secondary_zip");
			var formNameSecondaryCountry=autofillPrefs.getCharPref("form_name.secondary_country");
			var formNameSecondaryCountryCode=autofillPrefs.getCharPref("form_name.secondary_country_code");

			var debug=autofillPrefs.getBoolPref("debug");
			
			var versionNumber=autofillPrefs.getCharPref("version");
			
			// delete the whole autofill Branch
			autofillPrefs.deleteBranch("");
			
			autofillPrefs.setBoolPref("debug",debug);

			autofillPrefs.setCharPref("version",versionNumber);

			// form name associations
			autofillPrefs.setCharPref("form_name.title",formNameTitle);
			autofillPrefs.setCharPref("form_name.first_name",formNameFirstName);
			autofillPrefs.setCharPref("form_name.middle_name",formNameMiddleName);
			autofillPrefs.setCharPref("form_name.last_name",formNameLastName);
			autofillPrefs.setCharPref("form_name.suffix",formNameSuffix);
			autofillPrefs.setCharPref("form_name.email_address",formNameEmailAddress);
			autofillPrefs.setCharPref("form_name.phone_number",formNamePhoneNumber);

			// internal form name associations
			autofillPrefs.setCharPref("form_name.full_name",formNameFullName);

			autofillPrefs.setCharPref("form_name.primary_line1",formNamePrimaryLine1);
			autofillPrefs.setCharPref("form_name.primary_line2",formNamePrimaryLine2);
			autofillPrefs.setCharPref("form_name.primary_city",formNamePrimaryCity);
			autofillPrefs.setCharPref("form_name.primary_state",formNamePrimaryState);
			autofillPrefs.setCharPref("form_name.primary_zip",formNamePrimaryZip);
			autofillPrefs.setCharPref("form_name.primary_country",formNamePrimaryCountry);
			autofillPrefs.setCharPref("form_name.primary_country_code",formNamePrimaryCountryCode);

			autofillPrefs.setCharPref("form_name.secondary_line1",formNameSecondaryLine1);
			autofillPrefs.setCharPref("form_name.secondary_line2",formNameSecondaryLine2);
			autofillPrefs.setCharPref("form_name.secondary_city",formNameSecondaryCity);
			autofillPrefs.setCharPref("form_name.secondary_state",formNameSecondaryState);
			autofillPrefs.setCharPref("form_name.secondary_zip",formNameSecondaryZip);
			autofillPrefs.setCharPref("form_name.secondary_country",formNameSecondaryCountry);
			autofillPrefs.setCharPref("form_name.secondary_country_code",formNameSecondaryCountryCode);

}

function doCancel() {
	return true;
}

function doHelp() {
	alert("You pressed Help!");
	return true;
}

function autofillPrefLoadSettings() {

	populateCountryMenu(document.getElementById("autofill_primary_country"));
	populateCountryMenu(document.getElementById("autofill_secondary_country"));

	// Assume if autohighlight preference is set, that all the remaining preferences are set
	if (autofillPrefs.prefHasUserValue("autohighlight")) {
		document.getElementById("autofill_autohighlight").checked=autofillPrefs.getBoolPref("autohighlight");

		var profileList=autofillPrefs.getCharPref("profile_list");

		if (profileList.length>0) {
			// parse the profile list for each profile
			profiles=profileList.split(",");

			// iterate over the profiles and populate the arrays & attribute fields
			for (var i=0;i<profiles.length;++i) {
				// populate the profile select drop down
				document.getElementById("profile_menu").appendItem(profiles[i],profiles[i]);
				autofillProfileName[i]=profiles[i];

				if (i==0) {
					// Select the First Profile
					document.getElementById("profile_menu").selectedIndex=0;

					// Populate the text boxs w/ the first profile
					document.getElementById("autofill_title").value=autofillPrefs.getCharPref(profiles[i]+".title");
					document.getElementById("autofill_first_name").value=autofillPrefs.getCharPref(profiles[i]+".first_name");
					document.getElementById("autofill_middle_name").value=autofillPrefs.getCharPref(profiles[i]+".middle_name");
					document.getElementById("autofill_last_name").value=autofillPrefs.getCharPref(profiles[i]+".last_name");
					document.getElementById("autofill_suffix").value=autofillPrefs.getCharPref(profiles[i]+".suffix");
					document.getElementById("autofill_email_address").value=autofillPrefs.getCharPref(profiles[i]+".email_address");
					document.getElementById("autofill_phone_number").value=autofillPrefs.getCharPref(profiles[i]+".phone_number");

					document.getElementById("autofill_primary_line1").value=autofillPrefs.getCharPref(profiles[i]+".primary_line1");
					document.getElementById("autofill_primary_line2").value=autofillPrefs.getCharPref(profiles[i]+".primary_line2");
					document.getElementById("autofill_primary_city").value=autofillPrefs.getCharPref(profiles[i]+".primary_city");
					document.getElementById("autofill_primary_state").value=autofillPrefs.getCharPref(profiles[i]+".primary_state");
					document.getElementById("autofill_primary_zip").value=autofillPrefs.getCharPref(profiles[i]+".primary_zip");

					consoleDump("use_primary: " + profiles[i] + ":" + i);
					
					selectedPrimaryCountryCode=autofillPrefs.getCharPref(profiles[i]+".primary_country_code");
					selectCountry(document.getElementById("autofill_primary_country"),selectedPrimaryCountryCode);
					
						
					consoleDump("use_primary1: " + profiles[i] + ":" + i);
					document.getElementById("use_primary").checked=autofillPrefs.getBoolPref(profiles[i]+".use_primary");
					usePrimaryListener();

					document.getElementById("autofill_secondary_line1").value=autofillPrefs.getCharPref(profiles[i]+".secondary_line1");
					document.getElementById("autofill_secondary_line2").value=autofillPrefs.getCharPref(profiles[i]+".secondary_line2");
					document.getElementById("autofill_secondary_city").value=autofillPrefs.getCharPref(profiles[i]+".secondary_city");
					document.getElementById("autofill_secondary_state").value=autofillPrefs.getCharPref(profiles[i]+".secondary_state");
					document.getElementById("autofill_secondary_zip").value=autofillPrefs.getCharPref(profiles[i]+".secondary_zip");

					selectedSecondaryCountryCode=autofillPrefs.getCharPref(profiles[i]+".secondary_country_code");
					selectCountry(document.getElementById("autofill_secondary_country"),selectedSecondaryCountryCode);
				}

				// populate the arrays
				autofillTitle[i]=autofillPrefs.getCharPref(profiles[i]+".title");
				autofillFirstName[i]=autofillPrefs.getCharPref(profiles[i]+".first_name");
				autofillMiddleName[i]=autofillPrefs.getCharPref(profiles[i]+".middle_name");
				autofillLastName[i]=autofillPrefs.getCharPref(profiles[i]+".last_name");
				autofillSuffix[i]=autofillPrefs.getCharPref(profiles[i]+".suffix");
				autofillEmailAddress[i]=autofillPrefs.getCharPref(profiles[i]+".email_address");
				autofillPhoneNumber[i]=autofillPrefs.getCharPref(profiles[i]+".phone_number");

				autofillPrimaryLine1[i]=autofillPrefs.getCharPref(profiles[i]+".primary_line1");
				autofillPrimaryLine2[i]=autofillPrefs.getCharPref(profiles[i]+".primary_line2");
				autofillPrimaryCity[i]=autofillPrefs.getCharPref(profiles[i]+".primary_city");
				autofillPrimaryState[i]=autofillPrefs.getCharPref(profiles[i]+".primary_state");
				autofillPrimaryZip[i]=autofillPrefs.getCharPref(profiles[i]+".primary_zip");
				autofillPrimaryCountryCode[i]=autofillPrefs.getCharPref(profiles[i]+".primary_country_code");

				autofillUsePrimary[i]=autofillPrefs.getBoolPref(profiles[i]+".use_primary");

				autofillSecondaryLine1[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_line1");
				autofillSecondaryLine2[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_line2");
				autofillSecondaryCity[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_city");
				autofillSecondaryState[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_state");
				autofillSecondaryZip[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_zip");
				autofillSecondaryCountryCode[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_country_code");

			}
		}
		else {
			document.getElementById("del_profile").setAttribute("disabled","true");
			disableAllAttributes();
		}
	}
	else {
		document.getElementById("del_profile").setAttribute("disabled","true");
		disableAllAttributes();
	}
	
}

function selectCountry(menulist,selectedCountryCode) {
	menuitems=menulist.firstChild.childNodes;

	for (var i=0;i<menuitems.length;++i) {
		if (menuitems[i].getAttribute("value")==selectedCountryCode) {
			menulist.selectedIndex=i;
			break;
		}
	}					
}


// populate the Country DropDowns (the menulist, not the menupopup is passed in)
function populateCountryMenu(element) {
	var i=0;
	for (var aCountry in countries) {
		createMenuItem(element.firstChild,countries[aCountry],i,aCountry);
		++i;
	}
}

function createMenuItem(element,aLabel,anIndex,aValue) {
	var menuitem = document.createElement("menuitem");
	
	menuitem.setAttribute("label",aLabel);
	menuitem.setAttribute("index",anIndex);
	menuitem.setAttribute("value",aValue);
	
	element.appendChild(menuitem);
}


function enableAllAttributes() {
	document.getElementById("autofill_title").removeAttribute("disabled");
	document.getElementById("autofill_first_name").removeAttribute("disabled");
	document.getElementById("autofill_middle_name").removeAttribute("disabled");
	document.getElementById("autofill_last_name").removeAttribute("disabled");
	document.getElementById("autofill_suffix").removeAttribute("disabled");
	document.getElementById("autofill_email_address").removeAttribute("disabled");
	document.getElementById("autofill_phone_number").removeAttribute("disabled");

	document.getElementById("autofill_primary_line1").removeAttribute("disabled");
	document.getElementById("autofill_primary_line2").removeAttribute("disabled");
	document.getElementById("autofill_primary_city").removeAttribute("disabled");
	document.getElementById("autofill_primary_state").removeAttribute("disabled");
	document.getElementById("autofill_primary_zip").removeAttribute("disabled");
	document.getElementById("autofill_primary_country").removeAttribute("disabled");

	document.getElementById("use_primary").removeAttribute("disabled");

	document.getElementById("autofill_secondary_line1").removeAttribute("disabled");
	document.getElementById("autofill_secondary_line2").removeAttribute("disabled");
	document.getElementById("autofill_secondary_city").removeAttribute("disabled");
	document.getElementById("autofill_secondary_state").removeAttribute("disabled");
	document.getElementById("autofill_secondary_zip").removeAttribute("disabled");
	document.getElementById("autofill_secondary_country").removeAttribute("disabled");
}

function disableAllAttributes() {
	document.getElementById("autofill_title").setAttribute("disabled","true");
	document.getElementById("autofill_first_name").setAttribute("disabled","true");
	document.getElementById("autofill_middle_name").setAttribute("disabled","true");
	document.getElementById("autofill_last_name").setAttribute("disabled","true");
	document.getElementById("autofill_suffix").setAttribute("disabled","true");
	document.getElementById("autofill_email_address").setAttribute("disabled","true");
	document.getElementById("autofill_phone_number").setAttribute("disabled","true");

	document.getElementById("autofill_primary_line1").setAttribute("disabled","true");
	document.getElementById("autofill_primary_line2").setAttribute("disabled","true");
	document.getElementById("autofill_primary_city").setAttribute("disabled","true");
	document.getElementById("autofill_primary_state").setAttribute("disabled","true");
	document.getElementById("autofill_primary_zip").setAttribute("disabled","true");
	document.getElementById("autofill_primary_country").setAttribute("disabled","true");

	document.getElementById("use_primary").setAttribute("disabled","true");

	document.getElementById("autofill_secondary_line1").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_line2").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_city").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_state").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_zip").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_country").setAttribute("disabled","true");		
}


function doAddProfile() {
	var newProfileValue = document.getElementById("new_profile").value;
	var items=document.getElementById("profile_menu").firstChild.childNodes;
	
	// If there are no profiles right now, reenable the attributes since they are currently cutoff
	if (items.length==0) {
		document.getElementById("del_profile").removeAttribute("disabled");
		enableAllAttributes();
	}

	// Don't allow duplicate profiles to be added
	if (newProfileValue.length>0) {
		for (var i=0;i<items.length;++i) {
			if (items[i].label==newProfileValue) {
				return true;
			}
		}

		// add the new profile to the list of profiles, and select it
		autofillProfileName[items.length]=newProfileValue;
		document.getElementById("profile_menu").appendItem(newProfileValue,newProfileValue);
		document.getElementById("profile_menu").selectedIndex=items.length;


		// clear the new profile textbox
		document.getElementById("new_profile").value="";

		clearTextBoxes();

		// set empty array elements just in case user doesn't set any values (so doOK will work)
		clearArrayElements(items.length);


	}

	return true;
}

function clearArrayElements(i) {
	autofillTitle[i]="";
	autofillFirstName[i]="";
	autofillMiddleName[i]="";
	autofillLastName[i]="";
	autofillSuffix[i]="";
	autofillEmailAddress[i]="";
	autofillPhoneNumber[i]="";

	autofillPrimaryLine1[i]="";
	autofillPrimaryLine2[i]="";
	autofillPrimaryCity[i]="";
	autofillPrimaryState[i]="";
	autofillPrimaryZip[i]="";
	autofillPrimaryCountryCode[i]="";

	autofillUsePrimary[i]=false;

	autofillSecondaryLine1[i]="";
	autofillSecondaryLine2[i]="";
	autofillSecondaryCity[i]="";
	autofillSecondaryState[i]="";
	autofillSecondaryZip[i]="";
	autofillSecondaryCountryCode[i]="";
}

function clearTextBoxes() {
	// Clear the General Elements
	document.getElementById("autofill_title").value="";
	document.getElementById("autofill_first_name").value="";
	document.getElementById("autofill_middle_name").value="";
	document.getElementById("autofill_last_name").value="";
	document.getElementById("autofill_suffix").value="";
	document.getElementById("autofill_email_address").value="";
	document.getElementById("autofill_phone_number").value="";

	// Clear Primary Address
	document.getElementById("autofill_primary_line1").value="";
	document.getElementById("autofill_primary_line2").value="";
	document.getElementById("autofill_primary_city").value="";
	document.getElementById("autofill_primary_state").value="";
	document.getElementById("autofill_primary_zip").value="";
	document.getElementById("autofill_primary_country").selectedIndex=-1;

	// Clear Use Primary Checkbox
	document.getElementById("use_primary").checked=false;
	usePrimaryListener();

	// Clear Secondary Address
	document.getElementById("autofill_secondary_line1").value="";
	document.getElementById("autofill_secondary_line2").value="";
	document.getElementById("autofill_secondary_city").value="";
	document.getElementById("autofill_secondary_state").value="";
	document.getElementById("autofill_secondary_zip").value="";
	document.getElementById("autofill_secondary_country").selectedIndex=-1;
}

function doDeleteProfile() {
	for (var i=document.getElementById("profile_menu").selectedIndex;i<(autofillProfileName.length-1);++i) {
		autofillProfileName[i]=autofillProfileName[i+1];

		autofillTitle[i]=autofillTitle[i+1];
		autofillFirstName[i]=autofillFirstName[i+1];
		autofillMiddleName[i]=autofillMiddleName[i+1];
		autofillLastName[i]=autofillLastName[i+1];
		autofillSuffix[i]=autofillSuffix[i+1];
		autofillEmailAddress[i]=autofillEmailAddress[i+1];
		autofillPhoneNumber[i]=autofillPhoneNumber[i+1];

		autofillPrimaryLine1[i]=autofillPrimaryLine1[i+1];
		autofillPrimaryLine2[i]=autofillPrimaryLine2[i+1];
		autofillPrimaryCity[i]=autofillPrimaryCity[i+1];
		autofillPrimaryState[i]=autofillPrimaryState[i+1];
		autofillPrimaryZip[i]=autofillPrimaryZip[i+1];
		autofillPrimaryCountryCode[i]=autofillPrimaryCountryCode[i+1];

		autofillUsePrimary[i]=autofillUsePrimary[i+1];

		autofillSecondaryLine1[i]=autofillSecondaryLine1[i+1];
		autofillSecondaryLine2[i]=autofillSecondaryLine2[i+1];
		autofillSecondaryCity[i]=autofillSecondaryCity[i+1];
		autofillSecondaryState[i]=autofillSecondaryState[i+1];
		autofillSecondaryZip[i]=autofillSecondaryZip[i+1];
		autofillSecondaryCountryCode[i]=autofillSecondaryCountryCode[i+1];
	}
	
	autofillProfileName[autofillProfileName.length-1]="";
	autofillProfileName.length -= 1;

	clearArrayElements(autofillTitle.length-1);
	
	autofillTitle.length -= 1;
	autofillFirstName.length -= 1;
	autofillMiddleName.length -= 1;
	autofillLastName.length -= 1;
	autofillSuffix.length -= 1;
	autofillEmailAddress.length -= 1;
	autofillPhoneNumber.length -= 1;
	
	autofillPrimaryLine1.length -= 1;
	autofillPrimaryLine2.length -= 1;
	autofillPrimaryCity.length -= 1;
	autofillPrimaryState.length -= 1;
	autofillPrimaryZip.length -= 1;
	autofillPrimaryCountryCode.length -= 1;
	
	autofillUsePrimary.length -= 1;
	
	autofillSecondaryLine1.length -= 1;
	autofillSecondaryLine2.length -= 1;
	autofillSecondaryCity.length -= 1;
	autofillSecondaryState.length -= 1;
	autofillSecondaryZip.length -= 1;
	autofillSecondaryCountryCode.length -= 1;

	var tempIndex=document.getElementById("profile_menu").selectedIndex;
	document.getElementById("profile_menu").removeItemAt(document.getElementById("profile_menu").selectedIndex);
	document.getElementById("profile_menu").selectedIndex=-1;
	
	if (tempIndex>=autofillProfileName.length) {
		if (autofillProfileName.length==0) {
			document.getElementById("del_profile").setAttribute("disabled","true");
			doProfileSelect();	
			disableAllAttributes();
		}
		else {
			document.getElementById("profile_menu").selectedIndex=autofillProfileName.length-1;
			doProfileSelect();	
		}
	}
	else {
		document.getElementById("profile_menu").selectedIndex=tempIndex;
		doProfileSelect();	
	}
	
	return true;
}

// populate "element" with the value passed, or empty it if value isn't set
function setTextAttributes(element,value) {
	if (value!=null) {
		element.value=value;
	}
	else {
		element.value="";
	}
}

// populate the attributes with the values associated with the selected profile
function doProfileSelect() {
	
	// Load the text box values when a new profile is selected
	
	// Load General Settings
	setTextAttributes(document.getElementById("autofill_title"),autofillTitle[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_first_name"),autofillFirstName[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_middle_name"),autofillMiddleName[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_last_name"),autofillLastName[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_suffix"),autofillSuffix[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_email_address"),autofillEmailAddress[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_phone_number"),autofillPhoneNumber[document.getElementById("profile_menu").selectedIndex]);

	// Load Primary Address
	setTextAttributes(document.getElementById("autofill_primary_line1"),autofillPrimaryLine1[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_primary_line2"),autofillPrimaryLine2[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_primary_city"),autofillPrimaryCity[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_primary_state"),autofillPrimaryState[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_primary_zip"),autofillPrimaryZip[document.getElementById("profile_menu").selectedIndex]);
	selectCountry(document.getElementById("autofill_primary_country"),autofillPrimaryCountryCode[document.getElementById("profile_menu").selectedIndex]);

	// Load Use Primary Checkbox
	document.getElementById("use_primary").checked=autofillUsePrimary[document.getElementById("profile_menu").selectedIndex];
	usePrimaryListener();
	
	// Load Secondary Address
	setTextAttributes(document.getElementById("autofill_secondary_line1"),autofillSecondaryLine1[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_secondary_line2"),autofillSecondaryLine2[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_secondary_city"),autofillSecondaryCity[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_secondary_state"),autofillSecondaryState[document.getElementById("profile_menu").selectedIndex]);
	setTextAttributes(document.getElementById("autofill_secondary_zip"),autofillSecondaryZip[document.getElementById("profile_menu").selectedIndex]);
	selectCountry(document.getElementById("autofill_secondary_country"),autofillSecondaryCountryCode[document.getElementById("profile_menu").selectedIndex]);
		
	return true;
}

// Save the Profile Values each time a textbox loses focus (Can't wait till profile is complete because you've already lost
// which profile is currently selected by that time)
function saveProfileValues(event) {
	consoleDump("event: " + event.target.id + ":" + event.target.value);

	// Save General Settings
	if (event.target.id=="autofill_title") {
		autofillTitle[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_title").value;
	}
	
	if (event.target.id=="autofill_first_name") {
		autofillFirstName[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_first_name").value;
	}
	if (event.target.id=="autofill_middle_name") {
		autofillMiddleName[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_middle_name").value;
	}
	if (event.target.id=="autofill_last_name") {
		autofillLastName[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_last_name").value;
	}
	if (event.target.id=="autofill_suffix") {
		autofillSuffix[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_suffix").value;
	}
	if (event.target.id=="autofill_email_address") {
		autofillEmailAddress[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_email_address").value;
	}
	if (event.target.id=="autofill_phone_number") {
		autofillPhoneNumber[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_phone_number").value;
	}

	// Save Primary Address
	if (event.target.id=="autofill_primary_line1") {
		autofillPrimaryLine1[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_line1").value;
	}
	if (event.target.id=="autofill_primary_line2") {
		autofillPrimaryLine2[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_line2").value;
	}
	if (event.target.id=="autofill_primary_city") {
		autofillPrimaryCity[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_city").value;
	}
	if (event.target.id=="autofill_primary_state") {
		autofillPrimaryState[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_state").value;
	}
	if (event.target.id=="autofill_primary_zip") {
		autofillPrimaryZip[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_zip").value;
	}

	// Save Secondary Address
	if (event.target.id=="autofill_secondary_line1") {
		autofillSecondaryLine1[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_line1").value;
	}
	if (event.target.id=="autofill_secondary_line2") {
		autofillSecondaryLine2[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_line2").value;
	}
	if (event.target.id=="autofill_secondary_city") {
		autofillSecondaryCity[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_city").value;
	}
	if (event.target.id=="autofill_secondary_state") {
		autofillSecondaryState[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_state").value;
	}
	if (event.target.id=="autofill_secondary_zip") {
		autofillSecondaryZip[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_zip").value;
	}
}

function setPrimaryCountryValues(event) {
		autofillPrimaryCountryCode[document.getElementById("profile_menu").selectedIndex]=event.target.value;
		consoleDump("Primary: " + autofillPrimaryCountryCode[document.getElementById("profile_menu").selectedIndex] + ":" + event.target.value + ":" + countries[event.target.value]);
}

function setSecondaryCountryValues(event) {
		autofillSecondaryCountryCode[document.getElementById("profile_menu").selectedIndex]=event.target.value;
		consoleDump("Secondary: " + autofillSecondaryCountryCode[document.getElementById("profile_menu").selectedIndex] + ":" + event.target.value + ":" + countries[event.target.value]);
}

